c  $Header: /usr/people/flittner/radtran/tomrad/pv2.2/src/RCS/cek67.f,v 2.22 2000/08/30 16:38:09 flittner Exp $
      subroutine cek67 (nc,ncp1)
c
c***********************************************************************
cccc
c     subroutine cek67
c     version oct 13,1995
c
c     purpose
c
c        Calculate the integration factors for the upward flux at the
c        top of the atmosphere.
c
c     calling sequence
c        call expone (ncp,ncp1)
c
c        variable   type    i/o  description
c        --------   ----    ---  ------------
c
c        nc         i*4     i    # of layers from top of
c                                atmosphere to reflecting surface
c        ncp1       i*4     o    nc+1
c
c     external references
c        dexpk1
c
c     common areas referenced
c        es
c        consts
c        thkns
c        depolt
c
c     written by d.e. flittner (modified from expone.f)
c
c     last modified: 09/23/96...dave flittner
c     purpose: Modify for depolarization ratio (ipol.ne.0)
c
cccc
c***********************************************************************
c
      implicit none
c
      include 'parameter.inc'
c passed
      integer nc,ncp1
c local
      integer i
c
c  common block area
c
      include 'es.cmn'
      include 'uptoa.cmn'
      include 'thkns.cmn'
      include 'consts.cmn'
      include 'depolt.cmn'
c
c now compute the integration terms for the calc of the upward flux at
c the top of the atmosphere.
c      j=1
      do i=1,ncp1-2
         call dexpk(tt(i),tt(1))
         if(ipol.eq.0)then
           ek6(i)=(e(2)+e(4))*dtsp(i)
           ek7(i)=sq2*(e(2)-e(4))*dtsp(i)
         else
           ek6(i)=((1.0d0+2.0d0*q)*e(2)+e(4))*dtsp(i)
           ek7(i)=delp*(e(2)-e(4))*dtsp(i)
         endif
      enddo
c      i=nc
      call dexpk(tt(nc),tt(1))
      if(ipol.eq.0)then
        ek6(nc)=(e(2)+e(4))*dtsp(nc)
        ek7(nc)=sq2*(e(2)-e(4))*dtsp(nc)
      else
        ek6(nc)=((1.0d0+2.0d0*q)*e(2)+e(4))*dtsp(nc)
        ek7(nc)=delp*(e(2)-e(4))*dtsp(nc)
      endif
c      i=ncp1
      if(ipol.eq.0)then
        ek6(ncp1)=(e(2)+e(4))*dtsp(ncp1)
        ek7(ncp1)=sq2*(e(2)-e(4))*dtsp(ncp1)
      else
        ek6(ncp1)=((1.0d0+2.0d0*q)*e(2)+e(4))*dtsp(ncp1)
        ek7(ncp1)=delp*(e(2)-e(4))*dtsp(ncp1)
      endif
      return
      end
