c  $Header: /usr/people/flittner/radtran/tomrad/pv2.2/src/RCS/cmn_datablk.f,v 2.22 2000/08/30 16:38:09 flittner Exp $
      block data cmn_datablk
c
c initialize the values for some elements of a few common blocks
c last mod. Sep. 6, 1998...def
c purpose: combine several commons into the switches common.  Also have
c 2 files (ascii and binary) for the fluxout stuff.
c
c last mod. Oct. 14, 1998...def
c purpose: add userfn (user input profile file name).
c
c     last mod. May 3, 1999...def
c     purpose: add option to compute addition absorbing gas profile using the
c     internal, implicit neutral density profile and a constant mixing ratio.
c     Currently it is set to do only o2 or o4 absorption and is controled by
c     the lo2abs and lo4abs logicals read in the ENV file.
c
c last mod. Feb. 10, 2000...def
c purpose: add switch to turn-off call to geopro
c
c
c
c***************************************************************************
c     
      implicit none
c
      include 'switches.cmn'
c if lsphout = True, then perform the out going beam using
c spherical geometry.  If False, then use flat atmosphere.
      data lsphout/.TRUE./
c perform the new gravity correction to the rayleight optical depth
      data gc_type/2/
c
c print the flux table
      data lprtflx/.TRUE./
c create files sumry.dat and tomnval.dat
      data jprint/0,0,0,0,0,0,0,0,1,1/
c
c standard mode is for reflected radiance
      data ldown/.FALSE./
c
c default is 1 table independent of phi
      data lphiindep/.TRUE./
c
c the flag to write the iterations to a file
c
      data write_iter_file/.FALSE./
c
c user the standard profile (PROF file)
c
      data prf_type/0/
      data irefrac/0/
c
c defaults for o2 and o4 absorption
c
      data lo2abs,lo4abs/.FALSE.,.FALSE./
c
c default for contribution function
c
      data lcontrb/.FALSE./
c
c default is to use the geometeric extrapolation (geopro)
c
      data lnoextrap/.FALSE./
c
c default is to NOT use the o3 weight temperatures in the user input profile
c
      data lwgttmp/.FALSE./
      data lwgt11/.FALSE./
c
      data lv7tab/.FALSE./
      data lv7tabout/.FALSE./
c
      data lbelowhorizon/.FALSE./
c
c the default file names
c
      include 'cfilenames.cmn'
      data inprffn/'PROF'/
      data nvalfn/'tomnval.dat'/
      data outerrfn/'dev_nul'/
      data outprffn/'profil.dat'/
      data sumryfn/'sumry.dat'/
      data iterfn/'iter.dat'/
      data coeffn/'coe.dat'/
      data outflxfnasc/'fluxout.asc'/
      data outflxfnbin/'fluxout.bin'/
      data userfn/'user.prf'/
      data outcontrbfn/'contrb.out'/
c
      include 'cgas2.cmn'
c only allow 1 absorbing gas when ngas=1
      data ngas/1/
c load the profile the first time
      data ildgas/0/
c the mixing ratio for o2
      data xo2/0.209476d0/
c
      include 'in.cmn'
c if ipsudo eq 1 then do spherical correction of solar beam
      data ipsudo/1/
c
      include 'consts.cmn'
      data Na/6.022045d23/
      data mair/28.964d-03/
      data g0/9.80665d0/
      data p0/101325.0d0/
      end
