      subroutine cmptwgt11(p11log,t11ave,nx,p_101lg,t_101,n_101)
c 
c compute the ozone weighted temperature profile using only the 11 layer values of the
c ozone weighted temp.
c
c input:
c p11log - log of 11 pressure levels
c t11ave - ozone weighted temperature at 11 pressure levels
c 
c output:
c t_101 - ozone weighted temperature for the calc. of the ozone abs. coe.
c
c
      implicit none
c
      integer nx
      real*8 p11log(nx),t11ave(nx)
      integer n_101
      real*8 t_101(n_101),p_101lg(n_101)
c local
      integer l1,l2,mode,i,l,l1m1
      real*8 ct(101)
c
c*****evaluate ozone-weighted average temperatures for atmospheres
c     above lowest 61 output pressure levels using a spline fit to
c     points at input pressure levels
c
        l1=41
        l2=101
        l1m1=l1-1
          mode=0
          call spline(p11log,t11ave,nx,1.d30,1.d30,ct,mode)
          do 275 i = l1,l2
           call splint(p11log,t11ave,ct,nx,p_101lg(i),t_101(i),mode)
275       continue
c
c*****evaluate weighted temperatures in the upper most 40 layers
c     based on constant lapse rate of -1.5 degrees per layer)
          do 300 l=1,l1m1
           t_101(l)=t_101(l1)-1.5*(l1-l)
 300      continue
      return
      end
