c $Header: /usr/people/flittner/radtran/tomrad/pv2.2/src/RCS/crfndx.f,v 2.22 2000/08/30 16:38:09 flittner Exp $
      subroutine crfndx(w)
c
c compute the refraction index given the pressure and temperature profilea
c and the wavelength in um.
c
c Last mod. Nov. 11, 1998...def
c purpose: change the def. of rfndx to n-1.
c
      implicit none
c the rcs revision #
      character*20 rcsrev
      parameter (rcsrev='$Revision: 2.22 $')
c
      include 'atm_101.cmn'
c
c passed
      real*8 w
c external
      real*8 refmod
      external refmod
c local
      integer i
      real*8 p
c
c convert wavelength to um from A
      w=w*1.0e-04
      do i=1,n_101
c convert p from atm to mb
         p=p_101(i)*1013.25
         rfndx(i)=refmod(p,t_101(i),w)*1.0d-06
      enddo
cc for testing
c      do i=1,nz
cc         rfndx(i)=rfndx(1)*exp(7.*(alog(p(i))-alog(p(1)))/20000.)
c         rfndx(i)=rfndx(i)*1.0e-04
c      enddo
c convert wavelength to A from um
      w=w*1.0e+04
      return
      end
c
c
      real*8 function refmod(p,t,w)
c
c calc the reflractive modulus (N=(n-1)*1.0e06
c given, press (mb), temp (Celsius), wavelength (um)
c
      implicit none
c the rcs revision #
      character*20 rcsrev
      parameter (rcsrev='$Revision: 2.22 $')
c
c passed
      real*8 p,t,w
c local
      real*8 n,c2
c
      n=p/(t+273.16d0)
      c2=0.584d0/w/w+77.6d0
      refmod=c2*n
      end
