c  $Header: /usr/people/flittner/radtran/tomrad/pv2.2/src/RCS/iniclz.f,v 2.22 2000/08/30 16:38:09 flittner Exp $
      subroutine iniclz
c***********************************************************************
c
c        this subroutine initializes various numerical constants freque-
c        ntly used in various subroutines.
c
c     last modified 03/10/95...dave flittner
c     purpose: set radius of earth equal to value used to find earth
c     position (6378.145 km).
c
c     last modified 03/14/95...dave flittner
c     purpose: set pressure scale height used in gravity correction
c     to rayleigh scattering od.  Create new variable pscaleforg and
c     pass in common block consts.
c
c     last modified 03/13/97...dave flittner
c     purpose: Set value for Loschmidt's constant (number density
c     at standard temp and pressure).
c***********************************************************************
      implicit none
      include 'consts.cmn'
      include 'es.cmn'
c local
      integer*4 i
c
c     pi = dacos(-1.0d+00)
      pi = 3.1415926535d+00
      cnvrt = pi / 180.d+00
      dr = cnvrt
      pi_2=pi/2.0d0
c
c***** r is the radius of the earth in km.
c
      r = 6378.145d+00                                         !def
      rinv = 1.d+00 / r
      cons = r / 6393.d+00
      sq2 = dsqrt(2.d+00)
      c215 = 2.d+00 / 15.0d+00
      c815 = 4.0d+00 * c215
      c38sq2 = 0.375d+00 * sq2
      c1415 = 0.9333333333d0
      c2815 = 1.8666666667d0
      pscaleforg = 6.95d0/r                                    !def
      kskip=0
      numek = 606
      smallx = 1.0e-06
c
      odan(1)=1.d0
      do 10 i=2,6
         odan(i)=1.d0/float(i-1)
   10 continue
c
c number density at standard temp and pressure [cm-3]
c
      Nlosch=2.686754e19
      return
      end
